#include <iostream>
#include <stdio.h>
#include <algorithm>
long b[10000000];
long a[10000000];

using namespace std;

int main(){
    long n,m,c,i,j,s=0;
    long long p=1,r=1;;
    cin >> n >> m;
    for(i=1;i<=m;i++)
        cin >> b[i];
    cin >> c;
    for(i=1;i<=n;i++)
        a[i]=i;
    for(i=0;i<=n-m;i++)
        for(j=1;j<=m;j++)
        a[i+b[j]]=a[i+j];
    for(i=1;i<=n;i++)
    {
        if(i==1) p=c; r*=p;
        s+=a[i]*r;
    }

    if(s > 998244353) cout << s-998244353;
    else cout << abs(s);


    return 0;
}